> For the complete documentation index, see [llms.txt](https://doc.batch.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://doc.batch.com/developer/sdk/ios/event-dispatchers/custom.md).

# Custom

If for some reason, you need to implement your own dispatcher, you must create a `BatchEventDispatcherDelegate` and register it to the SDK using `[BatchEventDispatcher addDispatcher]`.

{% hint style="info" %}
You don't need to add a dispatcher if you're using one of the previous "ready-to-go" library ! It will be automatically registered.
{% endhint %}

{% tabs %}
{% tab title="Swift" %}

```swift
@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate, BatchEventDispatcherDelegate {
    
    func application(_ application: UIApplication,
                     didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        BatchSDK.start(withAPIKey: "YOUR_API_KEY")
        
        [...]

        BatchEventDispatcher.add(self)
        return true
    }
    
    func dispatchEvent(with type: BatchEventDispatcherType,
                         payload: BatchEventDispatcherPayload) {
        NSLog("Dispatcher: I'm dispatching an event");
    }
}

```

{% endtab %}

{% tab title="Objective-C" %}

```objectivec

// MYAppDelegate.h

@interface MYAppDelegate : UIResponder <UIApplicationDelegate,
                                        BatchEventDispatcherDelegate>

[...]

@end

// MYAppDelegate.m

@implementation MYAppDelegate

- (BOOL)application:(UIApplication *)application 
didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    [BatchSDK startWithAPIKey:@"MY_API_KEY"];
    
    [...]

    [BatchEventDispatcher addDispatcher:self];
    return YES;
}

- (void)dispatchEventWithType:(BatchEventDispatcherType)type 
                      payload:(nonnull id<BatchEventDispatcherPayload>)payload { 
    NSLog(@"Dispatcher: I'm dispatching an event");
}

@end
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
If the Batch SDK happens to be opt-out from, dispatchers won't receive any events.
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://doc.batch.com/developer/sdk/ios/event-dispatchers/custom.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
